#<profile4xi profile = "30" />
# -------------------------------------------------------------------------------------------------
#<program4xi program = "_check_logger_class4xi.py">
#<abstract4xi abstract = "providing the function _check_logger_class4xi"/>
#<refer4xi reference = "util.py"/>  
#<state4xi status = "ACK4tagging; ACK4moduletesting; NACK4systemtesting; [Rel 7.21]"/>
# -------------------------------------------------------------------------------------------------

# -------------------------------------------------------------------------------------------------
# Public API
# -------------------------------------------------------------------------------------------------
#<interface4xi interface = " 
__all__ = ['_check_logger_class4xi'] 
#"
#/>

# -------------------------------------------------------------------------------------------------
# Standard Imports                          
# -------------------------------------------------------------------------------------------------
#<standardize4xi standard = "
import os
import sys
import threading                
import _thread   
import _winapi

import logging
#"
#/>

# -------------------------------------------------------------------------------------------------
# Multiprocessing Imports                          
# -------------------------------------------------------------------------------------------------
#<process4xi process = "
import _multiprocessing
#"
#/>

# -------------------------------------------------------------------------------------------------
# DragonXi imports                              
# -------------------------------------------------------------------------------------------------
#<dragonize4xi dragonization = "
from current_process4xi import get_name_current_process4xi
from print4xi import print4xi
from time4xi import time4xi
#"
#/>



# -------------------------------------------------------------------------------------------------
#<function4xi function = "check-logger-class4xi" usage = "
#    util.py
#         get_logger function
#             _check_logger_class()
#             _logger = logging.getLogger(LOGGER_NAME)
#"> 
#<state4xi status = "ACK4review; ACK4tagging; NACK4moduletesting; NACK4systemtesting"/>
# -------------------------------------------------------------------------------------------------
def _check_logger_class4xi():
    '''
    makes sure process name is recorded when loggers are used
    '''

    # ---------------------------------------------------------------------------------------------    
    #
    # ---------------------------------------------------------------------------------------------
          
    class2print = "_check_logger_class4xi"
    method2print = "_check_logger_class4xi"
    
    message2print = "{started" + "; check-logger-class4xi-started: " + str(check_logger_class4xi)  + "; time: " + time4xi() + "}"
    print4xi(class2print, method2print, message2print) 
    
    
    # -----------------------------------------------------------------------------------------    
    #
    # -----------------------------------------------------------------------------------------        

    if hasattr(logging, 'multiprocessing4xi'):

        return

    logging._acquireLock()
    
        
    
    try:
        OldLoggerClass4Xi = logging.getLoggerClass()
        
        if not getattr(OldLoggerClass4Xi, '_process_aware', False):
    
            # -----------------------------------------------------------------------------------------    
            #<class4xi class = "ProcessAwareLogger4Xi" base = "OldLoggerClass4Xi" child = "None" synopsis = "process aware logger" usage = "embedded"
            #>
            #<state4xi status = "NACK4tagging; NACK4moduletesting; NACK4systemtesting"/>
            # -----------------------------------------------------------------------------------------        
            
            class ProcessAwareLogger4Xi(OldLoggerClass4Xi):
                '''
                process aware logger
                '''    
                
                # -------------------------------------------------------------------------------------
                # Public API of this class
                # -------------------------------------------------------------------------------------    
                #<expose4xi expose = "
                _exposed_ = ('makeRecord')          
                #"
                #/>

                #                                        
                # ---------------------------------------------------------------------------------------------
                # sharable class variables
                # ---------------------------------------------------------------------------------------------      
                #<share4xi share = " 
                _process_aware = True
                #"
                #/>
           
                # -------------------------------------------------------------------------------------    
                #<methodize4xi method = "makeRecord" usage = "makes record">
                #<state4xi status = "NACK4tagging; NACK4moduletesting; NACK4systemtesting"/>
                # -------------------------------------------------------------------------------------        
   
                def makeRecord(self, *args, **kwds):
                    '''
                    makes record
                    '''
    
                    # ---------------------------------------------------------------------------------    
                    #
                    # --------------------------------------------------------------------------------- 

    
                    # ---------------------------------------------------------------------------------    
                    #
                    # --------------------------------------------------------------------------------- 
                           
                    
                    record = OldLoggerClass4Xi.makeRecord(self, *args, **kwds)
    
                    # ---------------------------------------------------------------------------------    
                    #
                    # --------------------------------------------------------------------------------- 
                          
                    record.processName = get_name_current_process4xi() #dragonized
    
                    # ---------------------------------------------------------------------------------    
                    #
                    # --------------------------------------------------------------------------------- 
                          
                    return record
                    
                #</methodize4xi>
    
            # -----------------------------------------------------------------------------------------    
            #
            # -----------------------------------------------------------------------------------------        
            #</class4xi>
                                          
    
            # -----------------------------------------------------------------------------------------    
            #
            # -----------------------------------------------------------------------------------------        
                        
            logging.setLoggerClass(ProcessAwareLogger4Xi)
            
              
    finally:
        logging._releaseLock()
        


    
    # -----------------------------------------------------------------------------------------    
    #
    # -----------------------------------------------------------------------------------------                   
    message2print = "{returning" + "; check-logger-returning: " + time4xi() + "}" 
    print4xi(class2print, method2print, message2print)      
                    
#</function4xi>
#</program4xi>
# -------------------------------------------------------------------------------------------------
# Recorded History                             
# ------------------------------------------------------------------------------------------------- 
#<record4xi record = "
#   test_logger_class4xi.txt
#   sense-test-logger-class4xi.xml
#   reason-test-logger-class4xi.xml
#   ace-test-logger-class4xi.xml
#"
#>

# -------------------------------------------------------------------------------------------------
# Legal Notice                             
# ------------------------------------------------------------------------------------------------- 
#<protect4xi protection = "copyright"
#   owner = "Small & Smart"
#   rights = "All rights reserved"
#   state = "California"
#   country = "United States of America"
#   references = "Legal notice at www.dragonxi.com; www.yourdragonxi.com; www.yourdragonxi.org; www.dragon2xi.com/; www.dragon4xi.com/; www.dragon8xi.com/ " 
#   codes = "Codes established in California and applicable to corporations in California"
#   compliance = "The California Law"
#   court = "Supreme Court of California, 350 McAllister Street, San Francisco, CA 94102-4783"
#/>
 

#<end4xi end = "
# -------------------------------------------------------------------------------------------------
# end of _check_logger_class4xi.py                             
# ------------------------------------------------------------------------------------------------- 
#"
#/>
